package sun.applet;

import java.awt.event.ActionListener;
import java.util.HashMap;
import java.security.Permission;
import java.net.URLConnection;
import java.awt.Toolkit;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.Locale;
import java.io.Reader;
import java.awt.event.ActionEvent;
import java.awt.Graphics2D;
import java.awt.print.PageFormat;
import java.awt.Graphics;
import java.awt.print.PrinterException;
import javax.print.attribute.HashPrintRequestAttributeSet;
import java.awt.print.PrinterJob;
import java.io.ByteArrayOutputStream;
import java.awt.Point;
import java.security.AccessController;
import java.io.ObjectOutputStream;
import java.io.BufferedOutputStream;
import java.io.FileOutputStream;
import java.io.File;
import java.awt.FileDialog;
import java.security.PrivilegedAction;
import java.awt.Insets;
import java.awt.Dimension;
import java.util.Iterator;
import java.io.IOException;
import java.io.InputStream;
import java.util.Enumeration;
import java.net.SocketPermission;
import java.applet.Applet;
import sun.misc.Ref;
import java.awt.Image;
import java.applet.AudioClip;
import java.awt.MenuBar;
import java.awt.event.WindowEvent;
import java.awt.event.WindowAdapter;
import java.awt.MenuItem;
import java.awt.Menu;
import java.net.URL;
import java.util.Hashtable;
import java.util.Vector;
import java.util.Map;
import java.io.PrintStream;
import java.awt.Label;
import java.awt.print.Printable;
import java.applet.AppletContext;
import java.awt.Frame;

public class AppletViewer extends Frame implements AppletContext, Printable
{
    private static String defaultSaveFile;
    AppletViewerPanel panel;
    Label label;
    PrintStream statusMsgStream;
    AppletViewerFactory factory;
    private static Map audioClips;
    private static Map imageRefs;
    static Vector appletPanels;
    static Hashtable systemParam;
    static AppletProps props;
    static int c;
    private static int x;
    private static int y;
    private static final int XDELTA = 30;
    private static final int YDELTA = 30;
    static String encoding;
    private static AppletMessageHandler amh;
    
    public AppletViewer(int x, int y, URL url, Hashtable hashtable, PrintStream statusMsgStream, AppletViewerFactory factory) {
        this.factory = factory;
        this.statusMsgStream = statusMsgStream;
        this.setTitle(AppletViewer.amh.getMessage("tool.title", hashtable.get("code")));
        MenuBar baseMenuBar = factory.getBaseMenuBar();
        Menu m = new Menu(AppletViewer.amh.getMessage("menu.applet"));
        this.addMenuItem(m, "menuitem.restart");
        this.addMenuItem(m, "menuitem.reload");
        this.addMenuItem(m, "menuitem.stop");
        this.addMenuItem(m, "menuitem.save");
        this.addMenuItem(m, "menuitem.start");
        this.addMenuItem(m, "menuitem.clone");
        m.add(new MenuItem("-"));
        this.addMenuItem(m, "menuitem.tag");
        this.addMenuItem(m, "menuitem.info");
        this.addMenuItem(m, "menuitem.edit").disable();
        this.addMenuItem(m, "menuitem.encoding");
        m.add(new MenuItem("-"));
        this.addMenuItem(m, "menuitem.print");
        m.add(new MenuItem("-"));
        this.addMenuItem(m, "menuitem.props");
        m.add(new MenuItem("-"));
        this.addMenuItem(m, "menuitem.close");
        if (factory.isStandalone()) {
            this.addMenuItem(m, "menuitem.quit");
        }
        baseMenuBar.add(m);
        this.setMenuBar(baseMenuBar);
        this.add("Center", this.panel = new AppletViewerPanel(url, hashtable));
        this.add("South", this.label = new Label(AppletViewer.amh.getMessage("label.hello")));
        this.panel.init();
        AppletViewer.appletPanels.addElement(this.panel);
        this.pack();
        this.move(x, y);
        this.setVisible(true);
        this.addWindowListener(new WindowAdapter() {
            @Override
            public void windowClosing(WindowEvent windowEvent) {
                AppletViewer.this.appletClose();
            }
            
            @Override
            public void windowIconified(WindowEvent windowEvent) {
                AppletViewer.this.appletStop();
            }
            
            @Override
            public void windowDeiconified(WindowEvent windowEvent) {
                AppletViewer.this.appletStart();
            }
        });
        this.panel.addAppletListener(new AppletEventListener(this));
        this.showStatus(AppletViewer.amh.getMessage("status.start"));
        this.initEventQueue();
    }
    
    public MenuItem addMenuItem(Menu menu, String s) {
        MenuItem mi = new MenuItem(AppletViewer.amh.getMessage(s));
        mi.addActionListener(new AppletViewer.UserActionListener());
        return menu.add(mi);
    }
    
    private void initEventQueue() {
        String property = System.getProperty("appletviewer.send.event");
        if (property == null) {
            this.panel.sendEvent(1);
            this.panel.sendEvent(2);
            this.panel.sendEvent(3);
        }
        else {
            String[] splitSeparator = this.splitSeparator(",", property);
            for (int i = 0; i < splitSeparator.length; ++i) {
                System.out.println("Adding event to queue: " + splitSeparator[i]);
                if (splitSeparator[i].equals("dispose")) {
                    this.panel.sendEvent(0);
                }
                else if (splitSeparator[i].equals("load")) {
                    this.panel.sendEvent(1);
                }
                else if (splitSeparator[i].equals("init")) {
                    this.panel.sendEvent(2);
                }
                else if (splitSeparator[i].equals("start")) {
                    this.panel.sendEvent(3);
                }
                else if (splitSeparator[i].equals("stop")) {
                    this.panel.sendEvent(4);
                }
                else if (splitSeparator[i].equals("destroy")) {
                    this.panel.sendEvent(5);
                }
                else if (splitSeparator[i].equals("quit")) {
                    this.panel.sendEvent(6);
                }
                else if (splitSeparator[i].equals("error")) {
                    this.panel.sendEvent(7);
                }
                else {
                    System.out.println("Unrecognized event name: " + splitSeparator[i]);
                }
            }
            while (!this.panel.emptyEventQueue()) {}
            this.appletSystemExit();
        }
    }
    
    private String[] splitSeparator(String str, String s) {
        Vector<String> vector = new Vector();
        int beginIndex;
        int index;
        for (beginIndex = 0; (index = s.indexOf(str, beginIndex)) != -1; beginIndex = index + 1) {
            vector.addElement(s.substring(beginIndex, index));
        }
        vector.addElement(s.substring(beginIndex));
        String[] anArray = new String[vector.size()];
        vector.copyInto(anArray);
        return anArray;
    }
    
    @Override
    public AudioClip getAudioClip(URL url) {
        checkConnect(url);
        synchronized (AppletViewer.audioClips) {
            AudioClip audioClip = (AudioClip)AppletViewer.audioClips.get(url);
            if (audioClip == null) {
                AppletViewer.audioClips.put(url, audioClip = new AppletAudioClip(url));
            }
            return audioClip;
        }
    }
    
    @Override
    public Image getImage(URL url) {
        return getCachedImage(url);
    }
    
    static Image getCachedImage(URL url) {
        return (Image)getCachedImageRef(url).get();
    }
    
    static Ref getCachedImageRef(URL url) {
        synchronized (AppletViewer.imageRefs) {
            AppletImageRef appletImageRef = (AppletImageRef)AppletViewer.imageRefs.get(url);
            if (appletImageRef == null) {
                appletImageRef = new AppletImageRef(url);
                AppletViewer.imageRefs.put(url, appletImageRef);
            }
            return appletImageRef;
        }
    }
    
    static void flushImageCache() {
        AppletViewer.imageRefs.clear();
    }
    
    @Override
    public Applet getApplet(String lowerCase) {
        AppletSecurity appletSecurity = (AppletSecurity)System.getSecurityManager();
        lowerCase = lowerCase.toLowerCase();
        SocketPermission socketPermission = new SocketPermission(this.panel.getCodeBase().getHost(), "connect");
        Enumeration<Object> elements = AppletViewer.appletPanels.elements();
        while (elements.hasMoreElements()) {
            AppletPanel appletPanel = (AppletPanel)elements.nextElement();
            String anObject = appletPanel.getParameter("name");
            if (anObject != null) {
                anObject = anObject.toLowerCase();
            }
            if (lowerCase.equals(anObject) && appletPanel.getDocumentBase().equals(this.panel.getDocumentBase()) && socketPermission.implies(new SocketPermission(appletPanel.getCodeBase().getHost(), "connect"))) {
                return appletPanel.applet;
            }
            continue;
        }
        return null;
    }
    
    @Override
    public Enumeration getApplets() {
        AppletSecurity appletSecurity = (AppletSecurity)System.getSecurityManager();
        Vector<AppletPanel> vector = new Vector();
        SocketPermission socketPermission = new SocketPermission(this.panel.getCodeBase().getHost(), "connect");
        Enumeration<Object> elements = AppletViewer.appletPanels.elements();
        while (elements.hasMoreElements()) {
            AppletPanel appletPanel = (AppletPanel)elements.nextElement();
            if (appletPanel.getDocumentBase().equals(this.panel.getDocumentBase()) && socketPermission.implies(new SocketPermission(appletPanel.getCodeBase().getHost(), "connect"))) {
                vector.addElement(appletPanel.applet);
            }
            else {
                continue;
            }
        }
        return vector.elements();
    }
    
    @Override
    public void showDocument(URL url) {
    }
    
    @Override
    public void showDocument(URL url, String s) {
    }
    
    @Override
    public void showStatus(String text) {
        this.label.setText(text);
    }
    
    @Override
    public void setStream(String s, InputStream inputStream) throws IOException {
    }
    
    @Override
    public InputStream getStream(String s) {
        return null;
    }
    
    @Override
    public Iterator getStreamKeys() {
        return null;
    }
    
    public static void printTag(PrintStream printStream, Hashtable hashtable) {
        printStream.print("<applet");
        String str = (String)hashtable.get("codebase");
        if (str != null) {
            printStream.print(" codebase=\"" + str + "\"");
        }
        String str2 = (String)hashtable.get("code");
        if (str2 == null) {
            str2 = "applet.class";
        }
        printStream.print(" code=\"" + str2 + "\"");
        String str3 = (String)hashtable.get("width");
        if (str3 == null) {
            str3 = "150";
        }
        printStream.print(" width=" + str3);
        String str4 = (String)hashtable.get("height");
        if (str4 == null) {
            str4 = "100";
        }
        printStream.print(" height=" + str4);
        String str5 = (String)hashtable.get("name");
        if (str5 != null) {
            printStream.print(" name=\"" + str5 + "\"");
        }
        printStream.println(">");
        String[] array = new String[hashtable.size()];
        int n = 0;
        String anotherString;
        int n2;
        for (Enumeration keys = hashtable.keys(); keys.hasMoreElements(); array[n2] = anotherString, ++n) {
            for (anotherString = (String)keys.nextElement(), n2 = 0; n2 < n && array[n2].compareTo(anotherString) < 0; ++n2) {}
            System.arraycopy(array, n2, array, n2 + 1, n - n2);
        }
        for (String key : array) {
            if (AppletViewer.systemParam.get(key) == null) {
                printStream.println("<param name=" + key + " value=\"" + hashtable.get(key) + "\">");
            }
        }
        printStream.println("</applet>");
    }
    
    public void updateAtts() {
        Dimension size = this.panel.size();
        Insets insets = this.panel.insets();
        this.panel.atts.put("width", Integer.toString(size.width - (insets.left + insets.right)));
        this.panel.atts.put("height", Integer.toString(size.height - (insets.top + insets.bottom)));
    }
    
    void appletRestart() {
        this.panel.sendEvent(4);
        this.panel.sendEvent(5);
        this.panel.sendEvent(2);
        this.panel.sendEvent(3);
    }
    
    void appletReload() {
        this.panel.sendEvent(4);
        this.panel.sendEvent(5);
        this.panel.sendEvent(0);
        AppletPanel.flushClassLoader(this.panel.getClassLoaderCacheKey());
        try {
            this.panel.joinAppletThread();
            this.panel.release();
        }
        catch (InterruptedException ex) {
            return;
        }
        this.panel.createAppletThread();
        this.panel.sendEvent(1);
        this.panel.sendEvent(2);
        this.panel.sendEvent(3);
    }
    
    void appletSave() {
        AccessController.doPrivileged(new PrivilegedAction() {
            @Override
            public Object run() {
                AppletViewer.this.panel.sendEvent(4);
                FileDialog fileDialog = new FileDialog(AppletViewer.this, AppletViewer.amh.getMessage("appletsave.filedialogtitle"), 1);
                fileDialog.setDirectory(System.getProperty("user.dir"));
                fileDialog.setFile(AppletViewer.defaultSaveFile);
                fileDialog.show();
                String file = fileDialog.getFile();
                if (file == null) {
                    AppletViewer.this.panel.sendEvent(3);
                    return null;
                }
                File file2 = new File(fileDialog.getDirectory(), file);
                try (final FileOutputStream out = new FileOutputStream(file2);
                     final BufferedOutputStream out2 = new BufferedOutputStream(out);
                     final ObjectOutputStream objectOutputStream = new ObjectOutputStream(out2)) {
                    AppletViewer.this.showStatus(AppletViewer.amh.getMessage("appletsave.err1", AppletViewer.this.panel.applet.toString(), file2.toString()));
                    objectOutputStream.writeObject(AppletViewer.this.panel.applet);
                }
                catch (IOException ex) {
                    System.err.println(AppletViewer.amh.getMessage("appletsave.err2", ex));
                }
                finally {
                    AppletViewer.this.panel.sendEvent(3);
                }
                return null;
            }
        });
    }
    
    void appletClone() {
        Point location = this.location();
        this.updateAtts();
        this.factory.createAppletViewer(location.x + 30, location.y + 30, this.panel.documentURL, (Hashtable)this.panel.atts.clone());
    }
    
    void appletTag() {
        ByteArrayOutputStream out = new ByteArrayOutputStream();
        this.updateAtts();
        printTag(new PrintStream(out), this.panel.atts);
        this.showStatus(AppletViewer.amh.getMessage("applettag"));
        Point location = this.location();
        new TextFrame(location.x + 30, location.y + 30, AppletViewer.amh.getMessage("applettag.textframe"), out.toString());
    }
    
    void appletInfo() {
        String str = this.panel.applet.getAppletInfo();
        if (str == null) {
            str = AppletViewer.amh.getMessage("appletinfo.applet");
        }
        String s = str + "\n\n";
        String[][] parameterInfo = this.panel.applet.getParameterInfo();
        if (parameterInfo != null) {
            for (int i = 0; i < parameterInfo.length; ++i) {
                s = s + parameterInfo[i][0] + " -- " + parameterInfo[i][1] + " -- " + parameterInfo[i][2] + "\n";
            }
        }
        else {
            s += AppletViewer.amh.getMessage("appletinfo.param");
        }
        Point location = this.location();
        new TextFrame(location.x + 30, location.y + 30, AppletViewer.amh.getMessage("appletinfo.textframe"), s);
    }
    
    void appletCharacterEncoding() {
        this.showStatus(AppletViewer.amh.getMessage("appletencoding", AppletViewer.encoding));
    }
    
    void appletEdit() {
    }
    
    void appletPrint() {
        PrinterJob printerJob = PrinterJob.getPrinterJob();
        if (printerJob != null) {
            HashPrintRequestAttributeSet set = new HashPrintRequestAttributeSet();
            if (printerJob.printDialog(set)) {
                printerJob.setPrintable(this);
                try {
                    printerJob.print(set);
                    this.statusMsgStream.println(AppletViewer.amh.getMessage("appletprint.finish"));
                }
                catch (PrinterException ex) {
                    this.statusMsgStream.println(AppletViewer.amh.getMessage("appletprint.fail"));
                }
            }
            else {
                this.statusMsgStream.println(AppletViewer.amh.getMessage("appletprint.cancel"));
            }
        }
        else {
            this.statusMsgStream.println(AppletViewer.amh.getMessage("appletprint.fail"));
        }
    }
    
    @Override
    public int print(Graphics g, PageFormat pageFormat, int n) {
        if (n > 0) {
            return 1;
        }
        ((Graphics2D)g).translate(pageFormat.getImageableX(), pageFormat.getImageableY());
        this.panel.applet.printAll(g);
        return 0;
    }
    
    public static synchronized void networkProperties() {
        if (AppletViewer.props == null) {
            AppletViewer.props = new AppletProps();
        }
        AppletViewer.props.addNotify();
        AppletViewer.props.setVisible(true);
    }
    
    void appletStart() {
        this.panel.sendEvent(3);
    }
    
    void appletStop() {
        this.panel.sendEvent(4);
    }
    
    private void appletShutdown(AppletPanel appletPanel) {
        appletPanel.sendEvent(4);
        appletPanel.sendEvent(5);
        appletPanel.sendEvent(0);
        appletPanel.sendEvent(6);
    }
    
    void appletClose() {
        new Thread(new Runnable() {
            
            @Override
            public void run() {
                AppletViewer.access$300(AppletViewer.this, p);
                AppletViewer.appletPanels.removeElement(p);
                AppletViewer.this.dispose();
                if (AppletViewer.countApplets() == 0) {
                    AppletViewer.access$400(AppletViewer.this);
                }
            }
        }).start();
    }
    
    private void appletSystemExit() {
        if (this.factory.isStandalone()) {
            System.exit(0);
        }
    }
    
    protected void appletQuit() {
        new Thread(new Runnable() {
            @Override
            public void run() {
                Enumeration<Object> elements = AppletViewer.appletPanels.elements();
                while (elements.hasMoreElements()) {
                    AppletViewer.access$300(AppletViewer.this, (AppletPanel)elements.nextElement());
                }
                AppletViewer.access$400(AppletViewer.this);
            }
        }).start();
    }
    
    public void processUserAction(ActionEvent actionEvent) {
        String label = ((MenuItem)actionEvent.getSource()).getLabel();
        if (AppletViewer.amh.getMessage("menuitem.restart").equals(label)) {
            this.appletRestart();
            return;
        }
        if (AppletViewer.amh.getMessage("menuitem.reload").equals(label)) {
            this.appletReload();
            return;
        }
        if (AppletViewer.amh.getMessage("menuitem.clone").equals(label)) {
            this.appletClone();
            return;
        }
        if (AppletViewer.amh.getMessage("menuitem.stop").equals(label)) {
            this.appletStop();
            return;
        }
        if (AppletViewer.amh.getMessage("menuitem.save").equals(label)) {
            this.appletSave();
            return;
        }
        if (AppletViewer.amh.getMessage("menuitem.start").equals(label)) {
            this.appletStart();
            return;
        }
        if (AppletViewer.amh.getMessage("menuitem.tag").equals(label)) {
            this.appletTag();
            return;
        }
        if (AppletViewer.amh.getMessage("menuitem.info").equals(label)) {
            this.appletInfo();
            return;
        }
        if (AppletViewer.amh.getMessage("menuitem.encoding").equals(label)) {
            this.appletCharacterEncoding();
            return;
        }
        if (AppletViewer.amh.getMessage("menuitem.edit").equals(label)) {
            this.appletEdit();
            return;
        }
        if (AppletViewer.amh.getMessage("menuitem.print").equals(label)) {
            this.appletPrint();
            return;
        }
        if (AppletViewer.amh.getMessage("menuitem.props").equals(label)) {
            networkProperties();
            return;
        }
        if (AppletViewer.amh.getMessage("menuitem.close").equals(label)) {
            this.appletClose();
            return;
        }
        if (this.factory.isStandalone() && AppletViewer.amh.getMessage("menuitem.quit").equals(label)) {
            this.appletQuit();
            return;
        }
        return;
    }
    
    public static int countApplets() {
        return AppletViewer.appletPanels.size();
    }
    
    public static void skipSpace(Reader reader) throws IOException {
        while (AppletViewer.c >= 0 && (AppletViewer.c == 32 || AppletViewer.c == 9 || AppletViewer.c == 10 || AppletViewer.c == 13)) {
            AppletViewer.c = reader.read();
        }
    }
    
    public static String scanIdentifier(Reader reader) throws IOException {
        StringBuffer sb = new StringBuffer();
        while ((AppletViewer.c >= 97 && AppletViewer.c <= 122) || (AppletViewer.c >= 65 && AppletViewer.c <= 90) || (AppletViewer.c >= 48 && AppletViewer.c <= 57) || AppletViewer.c == 95) {
            sb.append((char)AppletViewer.c);
            AppletViewer.c = reader.read();
        }
        return sb.toString();
    }
    
    public static Hashtable scanTag(Reader reader) throws IOException {
        Hashtable<String, String> hashtable = new Hashtable();
        skipSpace(reader);
        while (AppletViewer.c >= 0 && AppletViewer.c != 62) {
            String scanIdentifier = scanIdentifier(reader);
            String string = "";
            skipSpace(reader);
            if (AppletViewer.c == 61) {
                int c = -1;
                AppletViewer.c = reader.read();
                skipSpace(reader);
                if (AppletViewer.c == 39 || AppletViewer.c == 34) {
                    c = AppletViewer.c;
                    AppletViewer.c = reader.read();
                }
                StringBuffer o = new StringBuffer();
                while (AppletViewer.c > 0 && ((c < 0 && AppletViewer.c != 32 && AppletViewer.c != 9 && AppletViewer.c != 10 && AppletViewer.c != 13 && AppletViewer.c != 62) || (c >= 0 && AppletViewer.c != c))) {
                    o.append((char)AppletViewer.c);
                    AppletViewer.c = reader.read();
                }
                if (AppletViewer.c == c) {
                    AppletViewer.c = reader.read();
                }
                skipSpace(reader);
                string = o.toString();
            }
            if (!string.equals("")) {
                hashtable.put(scanIdentifier.toLowerCase(Locale.ENGLISH), string);
            }
            while (AppletViewer.c != 62 && AppletViewer.c >= 0 && (AppletViewer.c < 97 || AppletViewer.c > 122) && (AppletViewer.c < 65 || AppletViewer.c > 90) && (AppletViewer.c < 48 || AppletViewer.c > 57) && AppletViewer.c != 95) {
                AppletViewer.c = reader.read();
            }
        }
        return hashtable;
    }
    
    private static Reader makeReader(InputStream inputStream) {
        if (AppletViewer.encoding != null) {
            try {
                return new BufferedReader(new InputStreamReader(inputStream, AppletViewer.encoding));
            }
            catch (IOException ex) {}
        }
        InputStreamReader in = new InputStreamReader(inputStream);
        AppletViewer.encoding = in.getEncoding();
        return new BufferedReader(in);
    }
    
    public static void parse(URL url, String encoding) throws IOException {
        AppletViewer.encoding = encoding;
        parse(url, System.out, new StdAppletViewerFactory());
    }
    
    public static void parse(URL url) throws IOException {
        parse(url, System.out, new StdAppletViewerFactory());
    }
    
    public static void parse(URL url, PrintStream printStream, AppletViewerFactory appletViewerFactory) throws IOException {
        int n = 0;
        String message = AppletViewer.amh.getMessage("parse.warning.requiresname");
        String message2 = AppletViewer.amh.getMessage("parse.warning.paramoutside");
        String message3 = AppletViewer.amh.getMessage("parse.warning.applet.requirescode");
        String message4 = AppletViewer.amh.getMessage("parse.warning.applet.requiresheight");
        String message5 = AppletViewer.amh.getMessage("parse.warning.applet.requireswidth");
        String message6 = AppletViewer.amh.getMessage("parse.warning.object.requirescode");
        String message7 = AppletViewer.amh.getMessage("parse.warning.object.requiresheight");
        String message8 = AppletViewer.amh.getMessage("parse.warning.object.requireswidth");
        String message9 = AppletViewer.amh.getMessage("parse.warning.embed.requirescode");
        String message10 = AppletViewer.amh.getMessage("parse.warning.embed.requiresheight");
        String message11 = AppletViewer.amh.getMessage("parse.warning.embed.requireswidth");
        String message12 = AppletViewer.amh.getMessage("parse.warning.appnotLongersupported");
        URLConnection openConnection = url.openConnection();
        Reader reader = makeReader(openConnection.getInputStream());
        url = openConnection.getURL();
        int n2 = 1;
        Hashtable<String, String> hashtable = null;
        while (true) {
            AppletViewer.c = reader.read();
            if (AppletViewer.c == -1) {
                break;
            }
            if (AppletViewer.c != 60) {
                continue;
            }
            AppletViewer.c = reader.read();
            if (AppletViewer.c == 47) {
                AppletViewer.c = reader.read();
                String scanIdentifier2 = scanIdentifier(reader);
                if (scanIdentifier2.equalsIgnoreCase("applet") || scanIdentifier2.equalsIgnoreCase("object") || scanIdentifier2.equalsIgnoreCase("embed")) {
                    if (n != 0 && hashtable.get("code") == null && hashtable.get("object") == null) {
                        printStream.println(message6);
                        hashtable = null;
                    }
                    if (hashtable != null) {
                        appletViewerFactory.createAppletViewer(AppletViewer.x, AppletViewer.y, url, hashtable);
                        AppletViewer.x += 30;
                        AppletViewer.y += 30;
                        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
                        if (AppletViewer.x > screenSize.width - 300 || AppletViewer.y > screenSize.height - 300) {
                            AppletViewer.x = 0;
                            AppletViewer.y = 2 * n2 * 30;
                            ++n2;
                        }
                    }
                    hashtable = null;
                    n = 0;
                }
                else {
                    continue;
                }
            }
            else {
                String scanIdentifier = scanIdentifier(reader);
                if (scanIdentifier.equalsIgnoreCase("param")) {
                    Hashtable<Object, Object> scanTag2 = scanTag(reader);
                    String s = (String)scanTag2.get("name");
                    if (s == null) {
                        printStream.println(message);
                    }
                    else {
                        String value2 = (String)scanTag2.get("value");
                        if (value2 == null) {
                            printStream.println(message);
                        }
                        else if (hashtable != null) {
                            hashtable.put(s.toLowerCase(), value2);
                        }
                        else {
                            printStream.println(message2);
                        }
                    }
                }
                else if (scanIdentifier.equalsIgnoreCase("applet")) {
                    hashtable = scanTag(reader);
                    if (hashtable.get("code") == null && hashtable.get("object") == null) {
                        printStream.println(message3);
                        hashtable = null;
                    }
                    else if (hashtable.get("width") == null) {
                        printStream.println(message5);
                        hashtable = null;
                    }
                    else if (hashtable.get("height") == null) {
                        printStream.println(message4);
                        hashtable = null;
                    }
                    else {
                        continue;
                    }
                }
                else if (scanIdentifier.equalsIgnoreCase("object")) {
                    n = 1;
                    hashtable = scanTag(reader);
                    if (hashtable.get("codebase") != null) {
                        hashtable.remove("codebase");
                    }
                    if (hashtable.get("width") == null) {
                        printStream.println(message8);
                        hashtable = null;
                    }
                    else if (hashtable.get("height") == null) {
                        printStream.println(message7);
                        hashtable = null;
                    }
                    else {
                        continue;
                    }
                }
                else if (scanIdentifier.equalsIgnoreCase("embed")) {
                    hashtable = scanTag(reader);
                    if (hashtable.get("code") == null && hashtable.get("object") == null) {
                        printStream.println(message9);
                        hashtable = null;
                    }
                    else if (hashtable.get("width") == null) {
                        printStream.println(message11);
                        hashtable = null;
                    }
                    else if (hashtable.get("height") == null) {
                        printStream.println(message10);
                        hashtable = null;
                    }
                    else {
                        continue;
                    }
                }
                else if (scanIdentifier.equalsIgnoreCase("app")) {
                    printStream.println(message12);
                    Hashtable<String, String> scanTag = scanTag(reader);
                    String str = (String)scanTag.get("class");
                    if (str != null) {
                        scanTag.remove("class");
                        scanTag.put("code", str + ".class");
                    }
                    String value = (String)scanTag.get("src");
                    if (value != null) {
                        scanTag.remove("src");
                        scanTag.put("codebase", value);
                    }
                    if (scanTag.get("width") == null) {
                        scanTag.put("width", "100");
                    }
                    if (scanTag.get("height") == null) {
                        scanTag.put("height", "100");
                    }
                    printTag(printStream, scanTag);
                    printStream.println();
                }
                else {
                    continue;
                }
            }
        }
        reader.close();
    }
    
    @Deprecated
    public static void main(String[] array) {
        Main.main(array);
    }
    
    private static void checkConnect(URL url) {
        SecurityManager securityManager = System.getSecurityManager();
        if (securityManager != null) {
            try {
                Permission permission = url.openConnection().getPermission();
                if (permission != null) {
                    securityManager.checkPermission(permission);
                }
                else {
                    securityManager.checkConnect(url.getHost(), url.getPort());
                }
            }
            catch (IOException ex) {
                securityManager.checkConnect(url.getHost(), url.getPort());
            }
        }
    }
    
    static void access$300(AppletViewer appletViewer, AppletPanel appletPanel) {
        appletViewer.appletShutdown(appletPanel);
    }
    
    static void access$400(AppletViewer appletViewer) {
        appletViewer.appletSystemExit();
    }
    
    static {
        AppletViewer.defaultSaveFile = "Applet.ser";
        AppletViewer.audioClips = new HashMap();
        AppletViewer.imageRefs = new HashMap();
        AppletViewer.appletPanels = new Vector();
        (AppletViewer.systemParam = new Hashtable()).put("codebase", "codebase");
        AppletViewer.systemParam.put("code", "code");
        AppletViewer.systemParam.put("alt", "alt");
        AppletViewer.systemParam.put("width", "width");
        AppletViewer.systemParam.put("height", "height");
        AppletViewer.systemParam.put("align", "align");
        AppletViewer.systemParam.put("vspace", "vspace");
        AppletViewer.systemParam.put("hspace", "hspace");
        AppletViewer.x = 0;
        AppletViewer.y = 0;
        AppletViewer.encoding = null;
        AppletViewer.amh = new AppletMessageHandler("appletviewer");
    }
    
    private final class UserActionListener implements ActionListener
    {
        @Override
        public void actionPerformed(ActionEvent actionEvent) {
            AppletViewer.this.processUserAction(actionEvent);
        }
    }
}
